#include <stdlib.h>
#include <avr/io.h>
#include "lcd.h"
#include "i2cmaster.h"
#include <string.h>
#include <stdio.h>

#define SLAVE_ADRESSE_MB 0x5A
#define SLAVE_ADRESSE_CPU 0x92
#define MB_TEMP		0x27
#define CPU_TEMP	00
static inline void _delayFourCycle(unsigned int __count)
	{
	if ( __count == 0 )    
		__asm__ __volatile__( "rjmp 1f\n 1:" );    // 2 cycles
	else
		__asm__ __volatile__ (
    	    	"1: sbiw %0,1" "\n\t"                  
    	    	"brne 1b"                              // 4 cycles/loop
    	    	: "=w" (__count)
    	    	: "0" (__count)
    	   	);
	}
#define delay(us)  _delayFourCycle( ( ( 1*(XTAL/4000) )*us)/1000 )

int main(void)
{
while(1){
	lcd_init(LCD_DISP_ON);
	lcd_clrscr();
	char temp1;
	char temp2;
	char string1[20];
	char string2[20];

	i2c_init();                         // initialize I2C library
	
	// read CPU-Temp

	i2c_start_wait(SLAVE_ADRESSE_CPU+I2C_WRITE);   // set device address and write
	//if(i2c_start(SLAVE_ADRESSE_CPU+I2C_WRITE)){
	i2c_write(CPU_TEMP);                    // starten
	//i2c_stop();

	i2c_rep_start(SLAVE_ADRESSE_CPU+I2C_READ);     // set device address and read
	temp1 = i2c_readAck();              // read one byte from EEPROM
	temp2 = i2c_readNak();
	i2c_stop();

	lcd_puts("CPU = ");
	ltoa (temp1, string1, 10);
	lcd_puts(string1);
	lcd_gotoxy(0, 1);
	//}
	//read MB-Temp

	i2c_start_wait(SLAVE_ADRESSE_MB+I2C_WRITE);   // set device address and write
	//if(i2c_start(SLAVE_ADRESSE_MB+I2C_WRITE)){
	i2c_write(MB_TEMP);                    // starten
	//i2c_stop();	

	i2c_rep_start(SLAVE_ADRESSE_MB+I2C_READ);     // set device address and read
	temp2 = i2c_readNak();
	i2c_stop();
	
	lcd_puts("MB  = ");
	ltoa (temp2, string2, 10);
	lcd_puts(string2);
	//}
	int i;
	lcd_puts(" |");
	i = 0;
	for(i; i<100; i++){
	delay(100000);
	}
	lcd_puts(" -");
	i = 0;
	for(i; i<100; i++){
	delay(100000);
	}
	
	
}
}
